'use strict';

var _powerAssertRecorder = function () { function PowerAssertRecorder() { this.captured = []; } PowerAssertRecorder.prototype._capt = function _capt(value, espath) { this.captured.push({ value: value, espath: espath }); return value; }; PowerAssertRecorder.prototype._expr = function _expr(value, source) { return { powerAssertContext: { value: value, events: this.captured }, source: source }; }; return PowerAssertRecorder; }(); /* eslint-env mocha */

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _babelCore = require('babel-core');

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _powerAssert = require('power-assert');

var _powerAssert2 = _interopRequireDefault(_powerAssert);

var _glob = require('glob');

var _glob2 = _interopRequireDefault(_glob);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var pluginPath = _path2.default.join(__dirname, '..', '..', 'dist', 'index.js');

var babelConfig = {
    plugins: ['syntax-jsx', 'transform-decorators-legacy', 'syntax-flow', 'syntax-decorators', [pluginPath, {
        addDebugId: true
    }]]
};
var create = false;

describe('transformTest', function () {
    _glob2.default.sync(__dirname + '/data/*.js').forEach(function (inName) {
        var rec = _path2.default.parse(inName);
        var outName = _path2.default.join(__dirname, 'data', 'out', rec.name + 'Out.js');
        it(rec.name, function () {
            var _rec = new _powerAssertRecorder();

            // const inFile = fs.readFileSync(inName).toString()
            var _transformFileSync = (0, _babelCore.transformFileSync)(inName, babelConfig),
                code = _transformFileSync.code;

            var outFile = void 0;
            if (create) {
                outFile = code;
                _fs2.default.writeFileSync(outName, outFile);
            } else {
                outFile = _fs2.default.readFileSync(outName).toString();
            }

            (0, _powerAssert2.default)(_rec._expr(_rec._capt(_rec._capt(code, 'arguments/0/left') === _rec._capt(outFile, 'arguments/0/right'), 'arguments/0'), {
                content: 'assert(code === outFile)',
                filepath: 'src/__tests__/transformTest.js',
                line: 39
            }));
        });
    });
});
//# sourceMappingURL=transformTest.js.map